with trace
without warning
include modex.e
include image.e
include get.e

constant width = 320, height = 240
constant count = 15
constant bmp = read_bitmap("spheres.bmp")

constant spheres = virtual_screen(length(bmp[2][1]), length(bmp[2]))
select_dest(spheres)
display_image({0,0}, bmp[2])
constant spherespal = get_palette(floor(bmp[1]/4))
puts(1, "mixing palettes... please be patient")
constant mixdata = mix_palette(spherespal, spherespal, 192)

constant back = virtual_screen(width,height)
sequence temp
temp = repeat(0, width)
for x = 1 to width do
    temp[x] = x - 1
end for
select_dest(back)
for y = 0 to height-1 do
    pixel(xor_bits(temp, y), {0,y})
end for
    
if mode_x(width,height) then
    abort(1)
end if
set_palette(spherespal, 0)


constant origin = new_command(originate, {0,0})
set_z_order(origin, 0)

set_clipping(0)
select_source(back)
select_dest(screen)
constant back2buffer = new_command(copy, {0,0,width,height,0,0})
set_z_order(back2buffer, 1)

constant wait = new_command(wait_retrace, {})
set_z_order(wait, 53)
constant pan = new_command(pan_to, {0, 0})
set_z_order(pan, 52)

sequence sprites
sprites = repeat(0, 15)

select_source(spheres)
select_dest(screen)
for i = 0 to count-1 do
    sprites[i+1] = new_command(clearmixcopy, {remainder(i,5)*32,floor(i/5)*32,32,32,0,0,mixdata})
    set_z_order(sprites[i+1], i+3)
end for        

sequence location, velocity, dist, vi, vj, nextloc
object vk, vl
integer py, junk
velocity = (rand(repeat({7,7}, 15)) - 4) / 2 
location = rand(repeat({width,height}-32, count))
py = 0

while get_key() = -1 do
    for i = 1 to count do
        nextloc = location[i] + velocity[i]
--        for j = 1 to length(location) do
--            if i != j then
--                dist = (location[i]+velocity[i]) - (location[j]+velocity[j])
--                dist = dist * dist
--                if dist[1] + dist[2] < 32*32 then  -- collision
--                    vi = velocity[i]
--                    vj = velocity[j]
--                    dist = ((location[j]+velocity[j]) - (location[i]+velocity[i])) 
--                    dist = dist / (sqrt(dist[1]*dist[1] + dist[2]*dist[2]))
----                    vk = vi*vi   vk = sqrt(vk[1]+vk[2]) * dist
----                    vl = vj*vj   vl = sqrt(vl[1]+vl[2]) * -dist
--                    vk = dist * sqrt(vi[1]*vi[1] + vi[2]*vi[2])
--                    vl = -dist * sqrt(vj[1]*vj[1] + vj[2]*vj[2])
--                    velocity[i] =  (vl - vk) / 2
--                    velocity[j] =   (vk - vl) / 2
--                end if
--            end if
--        end for
        if nextloc[2] > height-32 then
            nextloc[2] = height-32 - (nextloc[2] - (height-32))
            velocity[i][2] = -velocity[i][2]
        end if
        if nextloc[2] < 0 then
            nextloc[2] = -nextloc[2]
            velocity[i][2] = -velocity[i][2]
        end if
        if nextloc[1] > width-32 then
            nextloc[1] = width-32 - (nextloc[1] - (width-32))
            velocity[i][1] = -velocity[i][1]
        end if
        if nextloc[1] < 0 then
            nextloc[1] = -nextloc[1]
            velocity[i][1] = -velocity[i][1]
        end if
        location[i] = nextloc
        
        set_dest_pos(sprites[i], location[i])
    end for
    py = height - py
    set_source_pos(origin, {0,py})

    execute_commands()
end while
if graphics_mode(-1) then
end if

