-- demo3.ex
-- Pete Eberlein <xseal@harborside.com>
-- demo program for modex.e and mixcopy - shows lighting effect

without warning
include modex.e
include get.e

constant width = 320, height = 240

puts(1, "creating bitmaps...")
constant back = virtual_screen(width,height)
sequence temp
temp = repeat(0, width)
for x = 1 to width do
    temp[x] = x - 1
end for
select_dest(back)
for y = 0 to height-1 do
    pixel(xor_bits(temp, y), {0,y})
end for

constant shadescreen = virtual_screen(width,height+1)
select_dest(shadescreen)
for x = 1 to width do
    temp[x] = floor((x-width/2)*(x-width/2))
end for
for y = 0 to height do
    pixel(floor(-2-3*sqrt(temp + (y-height/2)*(y-height/2))), {0,y})
end for

puts(1, "\ncreating palette...")
sequence pal_s
pal_s = repeat({0,0,0}, 256)
for r = 0 to 5 do
    for g = 0 to 6 do
        for b = 0 to 5 do
            pal_s[(r*7+g)*6+b+1] = floor(5+58*{r/5,g/6,b/5})
        end for
    end for
end for

constant pal = get_palette(pal_s)

puts(1, "\nmixing palettes... please be patient")
constant mixdata = shade_palette({63,63,63}, pal)
   
constant origin = new_command(originate, {0,0})
set_z_order(origin, 1)

select_source(back)
select_dest(screen)
constant back2screen = new_command(copy, {0,0,width,height,0,0})
set_z_order(back2screen, 2)

select_source(shadescreen)
select_dest(screen)
constant mix = new_command(mixcopy, {0,0,width,height,0,0,mixdata})
set_z_order(mix, 3)

constant pan = new_command(pan_to, {0,0})
set_z_order(pan, 4)

constant wait = new_command(wait_retrace, {})
set_z_order(wait, 5)

if mode_x(width,height) then
    abort(1)
end if

set_palette(pal, 0)

integer x, py, junk
x = 0  
py = 0
while get_key() = -1 do
    py = height - py
    set_source_pos(origin, {0,py})

    set_source_pos(mix, {x,0})
    execute_commands()

    x = x + 1
    if x >= width then
        x = 0        
    end if
    
end while

junk = graphics_mode(-1)

